
package de.ivu.elect.presentation.wahlbeteiligung.action;

import javax.inject.Inject;

import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.wahlbeteiligung.boundary.WahlbeteiligungVerlaufConversationSelect;
import de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlauf;
import de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebietConstants;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.wahlbeteiligung.WahlbeteiligungVerlaufGebietSearchView;

public class WahlbeteiligungVerlaufGebietSearchAction extends AbstractWahlbeteiligungVerlaufAction {

  private static final long serialVersionUID = 1L;

  @Inject
  private WahlbeteiligungVerlaufConversationSelect wahlbeteiligungVerlaufConversationSelect;

  @View
  @Inject
  private transient WahlbeteiligungVerlaufGebietSearchView wahlbeteiligungVerlaufGebietSearchView;

  @Override
  protected UseCasePermission getRequiredPermission() {
    return UseCasePermission.WAHLBETEILIGUNG_VERLAUF_GEBIET_SEARCH;
  }

  @Override
  protected String doIt(WahlbeteiligungVerlauf wahlbeteiligungVerlauf) {
    wahlbeteiligungVerlaufConversationSelect.setEntity(wahlbeteiligungVerlauf);
    wahlbeteiligungVerlaufGebietSearchView.reset();
    return WahlbeteiligungVerlaufGebietSearchView.VIEW_ID;
  }

  @Override
  protected boolean isFireChangeEvent() {
    return false;
  }

  @Override
  protected String getLocalizedLabel() {
    return getMessage(getLabelKey(), getMessage(WahlbeteiligungVerlaufGebietConstants.MESSAGE_KEY_ENTITY_MEHRZAHL));
  }

  @Override
  public String getLabelKey() {
    return "entity.search.menu.item.label";
  }

  @Override
  public String getIcon() {
    return appIcons.getIconSearch();
  }


}
